#include <stdio.h>
#include <math.h>

double ftom(f)
 double f;
{
	if (f > 0) return (69. + (1./.057762265) * log(f/440.));
	else return (-1000);
}

main(argc, argv)
 char **argv;
{
	int half = 0, useamp = 0, p_kmax, count, xxx, bsize, i,
		pitch[1000], stime[1000], dur[1000], amp[1000], xx;
	if (argc < 5 || sscanf(argv[1], "%d", &useamp) < 1
		|| sscanf(argv[2], "%d", &half) < 1 ||
			sscanf(argv[3], "%d", &xx) < 1)
	{
		fprintf(stderr, "needs 2 args\n");
		exit(1);
	}
	if ((read(0, &p_kmax,sizeof(int))) != sizeof(int))
	{
		fprintf(stderr, "kmax: ");
		goto dammit;
	}
	if (p_kmax > 1000)
	{
		fprintf(stderr, "too big?\n");
		p_kmax = 1000;
	}
	if ((read(0,&xxx,sizeof(int))) != sizeof(int))
	{
		fprintf(stderr, "shit: ");
		goto dammit;
	}
	bsize = p_kmax * sizeof(int);
	if ((read(0,(char *)stime,  bsize))  !=  bsize)
	{
		fprintf(stderr, "duree: ");
		goto dammit;
	}
	if ((read(0,(char *)dur,  bsize))  !=  bsize)
	{
		fprintf(stderr, "longueur: ");
		goto dammit;
	}
	if ((read(0,(char *)pitch, bsize)) != bsize) 
	{
		fprintf(stderr, "coeff: ");
		goto dammit;
	}
	/* for (i = 0; i < 50; i++) fprintf(stderr, "%d\n", pitch[i]); */
	if (useamp)
	{
		if ((read(0,(char *)amp, bsize)) != bsize) 
		{
			fprintf(stderr, "amp: ");
			goto dammit;
		}
	}
	else
	{
		int i = p_kmax;
		int *ap = amp;
		for(; i-- ;ap++) *ap = 0x7fffffff;
	}
	if (half)
	{
		int i = p_kmax;
		int *ap = amp;
		for(; i-- ;ap++) *ap >>= 1;
	}
	fprintf(stderr, "(%d notes)\n",  p_kmax);
	/* printf("max v2;\n");
	printf("#N vpatcher 150 350 550 750;\n");
	printf("#P button 73 24;\n"); */
	printf("#P comment %d 30 50 1 %s;\n", 50 * xx, argv[4]);
	printf("#N explode;\n");
	printf("#X restore;\n");
	for (count = 0; count < p_kmax; count++)
	{
		float foo = ftom((261.623/256/256)* pitch[count]);
		int pit = 100*foo, vel = ((int)(127.5 + 10 * (log(amp[count]) -
				log(2147483648.))/log(2.)));
		if (pit < 0) pit = 0;
		/* fprintf(stderr, "%f %d\n", foo, pit); */
		printf("#X %d %d %d %d %d;\n", 
			stime[count], pit, (pit > 0? vel : 0),
			dur[count], 1);
	}
	printf("#X stop;\n");
	printf("#P newobj %d 57 68 1 explode;\n", 50*xx);
	/* printf("#P pop;\n"); */
	exit(0);

dammit:
	fprintf(stderr, "read error\n");
	exit(1);
}
