/*
program to calculate the transposition of a 4x harmonizer given the
harmonizer frequency in hex.  The output is in cents.  The constant
is deduced from the fact that 0x2000 used to transpose up an octave,
given a window of 0x40000 (which is twice that used for phasing).
*/

main(argc, argv)
 char **argv;
{
	int shift;
	if (argc < 2 || sscanf(argv[1], "%x", &shift) < 1) printf("???\n");
	else printf("%d\n", (int)(((shift<<8)>>8) * .10264));
	exit(0);
}
