int header[] =  {0x2e736e64, 0x0000001c, 0x10000000, 0x00000003, 0x0000ac44,
	0x00000001, 0x62617a00};

#include "math.h"
#define NPOINTS 512
#define MARGIN 64

main(argc, argv)
 char **argv;
{
	short sbuf[NPOINTS];
	int i;
	for (i = 0; i < NPOINTS; i++)
	{
		int j = (i >= NPOINTS/2 ? NPOINTS - i : i);
		float f;
		if (j < MARGIN) f = 0;
		else if (j >= 256 - MARGIN) f = 1.;
		else f = (j - MARGIN)/(256. - 2. * MARGIN);
		sbuf[i] = 32767. * cos(.5 * 3.14159 * (1. - f));
	}
	if (write(1, header, sizeof(header)) < sizeof(header) ||
		write(1, sbuf, sizeof(sbuf)) < sizeof(sbuf))
	{
		perror("write");
		exit(1);
	}
	exit(0);
}
